#!/usr/bin/perl

######################################################################
package Cognition::DocModel::Node;
######################################################################

sub uri
{
	my $this = shift;
	my $all  = shift;
	my @rv;
	
	if (length $this->{_dom}->getAttribute('id'))
	{
		push @rv, $this->{_page}->abs_url.'#'.$this->{_dom}->getAttribute('id');
	}
	push @rv, Cognition::HTMLParser::Utils::XPointer($this->{_dom}, $this->{_page}->abs_url);
	
	return $rv[0] unless (defined $all);
	while ($all) { shift @rv; $all--; }
	return @rv;
} #/sub uri


sub rdf_subject
{
	my $this = shift;

	# Create RDF subject
	my $subject = Cognition::RDFModel::Subject->new($this->uri);
	$subject->addObject($this);
	$subject->setDom($this->{_dom});

	if (defined $this->{up} && ref $this->{up} && UNIVERSAL::can($this->{up}, 'uri'))
	{
		my $val = Cognition::RDFModel::Value->new($this->{up}->uri, 1);
		$subject->addVal('http://purl.org/dc/terms/isPartOf', $val);
	}
	elsif (defined $this->{up} && ref $this->{up} && $this->{up}->{isRoot})
	{
		my $val = Cognition::RDFModel::Value->new($this->{_page}->abs_url, 1);
		$subject->addVal('http://purl.org/dc/terms/isPartOf', $val);
	}
	
	foreach my $k (@{$this->{kids}})
	{
		my $val = Cognition::RDFModel::Value->new($k->uri, 1);
		$subject->addVal('http://purl.org/dc/terms/hasPart', $val);
	}
	
	if (defined $this->{heading})
	{
		my $val = Cognition::RDFModel::Value->new($this->{heading});
		$subject->addVal('http://purl.org/dc/terms/title', $val);
	}
	
	return $subject;
} #/sub rdf_subject


sub metadata_ns
{
	return {};
}


1; #/package Cognition::DocModel::Node




